-- New view for evaluation. Cases which are marked for deletion (3) will not be
-- used in evaluation 

SET ROLE :db_adm;

BEGIN;

--
-- Init logging of DB updates.
--
CREATE TABLE db_history (
        id SERIAL PRIMARY KEY, 
        beschreibung VARCHAR(80), 
        zeitpunkt TIMESTAMP);
REVOKE ALL ON db_history FROM public;

INSERT INTO db_history (beschreibung, zeitpunkt) 
	VALUES ('update_1_0_2/00_hide_mark_delete_from_eval.sql', current_timestamp);

DROP VIEW master_tbl_eval_total_view CASCADE;

CREATE OR REPLACE  VIEW master_tbl_eval_total_view AS
    SELECT m.* FROM master_tbl m JOIN ka_status_tbl s
        ON m.id = s.master_id
        WHERE
            s.status <> 3 AND
            (m.bearbeiter_id = (getuserid())::integer)
            OR pg_has_role('admin_ka','MEMBER');

GRANT SELECT ON master_tbl_eval_total_view TO :cm_ka_group;
GRANT SELECT ON master_tbl_eval_total_view TO :admin_ka_group;

--
-- Name: master_tbl_eval_incm_view; Type: VIEW; Schema: public; Owner: postgres
--

CREATE OR REPLACE  VIEW master_tbl_eval_incm_view AS
    SELECT * FROM master_tbl_eval_total_view
        WHERE
            bereich_berufliche_qualifizierung = 1 OR
            bereich_berufsvorbereitung = 1 OR
            bildender_bereich = 1 OR
            bereich_lebensbewaeltigung = 1 OR
            sonstiger_foerderbedarf = 1;

GRANT SELECT ON public.master_tbl_eval_incm_view TO :cm_ka_group;
GRANT SELECT ON public.master_tbl_eval_incm_view TO :admin_ka_group;

COMMIT;
