BEGIN;
--
-- delete_master_ds() so umgebaut, dass nur noch Akten loesbar sind,
-- die sich im Zustand 'anoymisiert' (5) oder 'schwebend geloescht' (3)
-- befinden.
--
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt) 
	VALUES ('update_1_0_3/01_hotfix_delete_master_ds.sql', current_timestamp);

CREATE OR REPLACE FUNCTION delete_master_ds(mid integer) RETURNS void 
    LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER
    AS $$
DECLARE
    st integer;
BEGIN
    SELECT INTO st s.status FROM master_tbl m JOIN ka_status_tbl s
        ON s.master_id = m.id WHERE m.id = mid;

    IF NOT st in (3, 5) THEN
        RAISE EXCEPTION 'case is not deletable';
    END IF;

    DELETE FROM master_tbl WHERE id = mid;
END;
$$ ;

REVOKE ALL    ON FUNCTION delete_master_ds(integer) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION delete_master_ds(integer) TO GROUP :admin_ka_group;

COMMIT;
