BEGIN;
--
-- Tabellen fuer die Newsbox-erweiterung.
--
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
        VALUES ('update_1_0_4/10_zeitraum_trigger.sql', current_timestamp);


CREATE OR REPLACE FUNCTION set_zeitraum_cm() RETURNS TRIGGER AS $$
DECLARE
	zeitraum_new integer;
	zeitraum_old integer;
BEGIN
    SELECT INTO zeitraum_new (NEW.beendigung_5 - NEW.datum_feststellung)/7 FROM master_tbl_view  WHERE id = NEW.id;
    SELECT INTO zeitraum_old (OLD.beendigung_5 - OLD.datum_feststellung)/7 FROM master_tbl_view  WHERE id = OLD.id;
    IF zeitraum_new <> zeitraum_old OR (zeitraum_new IS NULL AND zeitraum_old
    IS NOT NULL) OR (zeitraum_new IS NOT NULL AND zeitraum_old IS NULL) THEN
    	IF zeitraum_new IS NOT NULL THEN
    	   UPDATE master_tbl_view SET zeitraum_fallmanagement = zeitraum_new WHERE
	   id = NEW.id;
    	ELSE
    	   UPDATE master_tbl_view SET zeitraum_fallmanagement = NULL WHERE id
	   = NEW.id;
    	END IF;
        RETURN NEW;
    END IF;
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

-- master_tbl

CREATE TRIGGER t_zeitraum_cm_update AFTER
    UPDATE ON master_tbl
    FOR EACH ROW EXECUTE PROCEDURE set_zeitraum_cm();

COMMIT;
