BEGIN;
--
SET ROLE :db_adm;
INSERT INTO db_history (beschreibung, zeitpunkt)
        VALUES ('update_1_0_4/12_phasen_auswertung.sql', current_timestamp);


DROP VIEW master_tbl_incm_view;
DROP VIEW master_tbl_eval_incm_view;
DROP VIEW master_tbl_eval_total_view;

-- Views

CREATE OR REPLACE  VIEW master_tbl_eval_total_view AS
    SELECT m.* FROM master_tbl m JOIN ka_status_tbl s
        ON m.id = s.master_id
        WHERE
            s.status <> 3 AND
            (m.bearbeiter_id = (getuserid())::integer)
            OR pg_has_role('admin_ka','MEMBER');

GRANT SELECT ON master_tbl_eval_total_view TO :cm_ka_group;
GRANT SELECT ON master_tbl_eval_total_view TO :admin_ka_group;


CREATE OR REPLACE  VIEW master_tbl_eval_incm_view AS
    SELECT * FROM master_tbl_eval_total_view
        WHERE phase IN (2,3,4,5);

GRANT SELECT ON public.master_tbl_eval_incm_view TO :cm_ka_group;
GRANT SELECT ON public.master_tbl_eval_incm_view TO :admin_ka_group;

CREATE OR REPLACE  VIEW master_tbl_incm_view AS
    SELECT * FROM master_tbl_view
        WHERE phase IN (2,3,4,5);


GRANT SELECT ON public.master_tbl_incm_view TO :cm_ka_group;
GRANT SELECT ON public.master_tbl_incm_view TO :admin_ka_group;

COMMIT;
