BEGIN;
--
-- NM-Tabelle um Nachrichten fuer bestimmte Nutzer als gelesen zu markieren. 
--
SET ROLE :db_adm;

CREATE TABLE nm_benutzer_nachrichten_tbl 
(
	id serial NOT NULL,
	benutzer_id int4 REFERENCES ka_benutzer_tbl(id) ON DELETE CASCADE,
	nachrichten_id int4 REFERENCES ka_nachrichten_tbl(id) ON DELETE CASCADE,
	gelesen timestamp DEFAULT now(),
	CONSTRAINT nm_benutzer_news_pkey PRIMARY KEY (id)
);

CREATE OR REPLACE  VIEW nm_benutzer_nachrichten_tbl_view AS
    SELECT id, benutzer_id, nachrichten_id, gelesen FROM nm_benutzer_nachrichten_tbl; 

GRANT SELECT ON nm_benutzer_nachrichten_tbl_view TO :cm_ka_group;
GRANT SELECT ON nm_benutzer_nachrichten_tbl_view TO :admin_ka_group;

INSERT INTO db_history (beschreibung, zeitpunkt)
        VALUES ('update_1_4_0/02_newsboard.sql', current_timestamp);

CREATE OR REPLACE FUNCTION markNewsAsRead( user_id integer, news_id integer) RETURNS VOID 
    LANGUAGE 'plpgsql' SECURITY DEFINER 
    AS $$
BEGIN
    INSERT INTO nm_benutzer_nachrichten_tbl (benutzer_id, nachrichten_id) VALUES (user_id, news_id);
END;
$$;

REVOKE ALL ON FUNCTION markNewsAsRead(user_id integer, news_id integer) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION markNewsAsRead(user_id integer, news_id integer) TO GROUP :cm_ka_group;

GRANT EXECUTE ON FUNCTION markNewsAsRead(user_id integer, news_id integer) TO GROUP :admin_ka_group;
COMMIT;
