BEGIN;

-- Disbable trigger
ALTER TABLE master_tbl DISABLE TRIGGER ALL;

SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
       VALUES ('update_1_5_6/02-zugang.sql', current_timestamp);

-- Neue Option "Der Jugendliche war bereits
ALTER TABLE master_tbl ADD war_ber_kunde INTEGER DEFAULT -1; 
ALTER TABLE master_tbl ADD CONSTRAINT master_tbl_war_ber_kunde_fkey FOREIGN KEY (war_ber_kunde) REFERENCES einverstaendniserklaerung_tbl(id);

-- Zugang des Jugendlichen

ALTER TABLE zugang_kompetenzagentur_tbl ALTER value TYPE VARCHAR(73);

-- Add new options
INSERT INTO zugang_kompetenzagentur_tbl (id, value) VALUES (16, 'Programm "Schulverweigerung - 2. Chance"');
INSERT INTO zugang_kompetenzagentur_tbl (id, value) VALUES (17, 'Programm "Stärken vor Ort"');
INSERT INTO zugang_kompetenzagentur_tbl (id, value) VALUES (18, 'Jugendgerichtshilfe, Bewährungshilfe');
INSERT INTO zugang_kompetenzagentur_tbl (id, value) VALUES (19, 'Bildungsträger');
INSERT INTO zugang_kompetenzagentur_tbl (id, value) VALUES (20, 'Andere "Kompetenzagentur"');
INSERT INTO zugang_kompetenzagentur_tbl (id, value) VALUES (21, 'Andere Schule (z.B. Berufsfachschule)');
INSERT INTO zugang_kompetenzagentur_tbl (id, value) VALUES (22, 'Programm "Jugendmigrationsdienste (JMD)"');
INSERT INTO zugang_kompetenzagentur_tbl (id, value) VALUES (23, 'Allgemeinbildende Schule');

-- Rename options
UPDATE zugang_kompetenzagentur_tbl set value = 'Eigenständiger Zugang des Jugendlichen' where id = 0;
UPDATE zugang_kompetenzagentur_tbl set value = 'Andere Menschen aus dem sozialen Umfeld des Jugendlichen' where id = 5;
UPDATE zugang_kompetenzagentur_tbl set value = 'Träger der Grundsicherung' where id = 7;
UPDATE zugang_kompetenzagentur_tbl set value = 'Aufsuchende Arbeit durch Kooperation mit Streetwork/mobiler Jugendarbeit' where id = 11;
UPDATE zugang_kompetenzagentur_tbl set value = 'Aufsuchende Arbeit durch die Kompetenzagentur' where id = 14;
UPDATE zugang_kompetenzagentur_tbl set value = 'Streetwork/mobile Jugendarbeit durch die Kompetenzagentur' where id = 15;

-- Alteintraege
UPDATE zugang_kompetenzagentur_tbl set value = 'Alteintrag "Schule"' where id = 10;
UPDATE zugang_kompetenzagentur_tbl set value = 'Alteintrag "Lehrer/Lehrerin"' where id = 4;
-- ENABLE trigger
SET ROLE postgres;
ALTER TABLE master_tbl ENABLE TRIGGER ALL;

COMMIT;
