BEGIN;

-- Disbable trigger
ALTER TABLE master_tbl DISABLE TRIGGER ALL;

SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
       VALUES ('update_1_5_6/03-eintritt.sql', current_timestamp);

CREATE TABLE letzte_jahr_allg_schule_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value character varying(13) NOT NULL
);

REVOKE ALL ON TABLE letzte_jahr_allg_schule_tbl FROM PUBLIC;
REVOKE ALL ON TABLE letzte_jahr_allg_schule_tbl FROM :db_adm;
GRANT ALL ON TABLE letzte_jahr_allg_schule_tbl TO :db_adm;
GRANT SELECT ON TABLE letzte_jahr_allg_schule_tbl TO :cm_group; 
GRANT SELECT ON TABLE letzte_jahr_allg_schule_tbl TO :admin_group; 

INSERT INTO letzte_jahr_allg_schule_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO letzte_jahr_allg_schule_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO letzte_jahr_allg_schule_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO letzte_jahr_allg_schule_tbl (id, value) VALUES (1, 'Ja');


ALTER TABLE master_tbl ADD berufsschulpflichtig INTEGER DEFAULT -1;
ALTER TABLE master_tbl ADD allgschulpflichtig INTEGER DEFAULT -1;
ALTER TABLE master_tbl ADD FOREIGN KEY (allgschulpflichtig) REFERENCES letzte_jahr_allg_schule_tbl(id); 
ALTER TABLE master_tbl ADD FOREIGN KEY (berufsschulpflichtig) REFERENCES letzte_jahr_allg_schule_tbl (id); 

-- Faelle die bereits anonymisiert, bzw. die schwebend anonymisiert sind,
-- werden auf unbekannt   
UPDATE master_tbl set berufsschulpflichtig = -3 where id in (select master_id from ka_status_tbl where status in (4,5));
UPDATE master_tbl set allgschulpflichtig   = -3 where id in (select master_id from ka_status_tbl where status in (4,5));

-- Faelle deren erstegespraech vor dem 31.08 liegen, oder kein erstgespraech
-- eingetragen haben, werden auf unbekannt gesetzt. 
UPDATE master_tbl set berufsschulpflichtig = -3 where coalesce(erstgespraech, '1970-01-01'::date) <= '2009-08-31'::date;
UPDATE master_tbl set allgschulpflichtig   = -3 where coalesce(erstgespraech, '1970-01-01'::date) <= '2009-08-31'::date;

-- ENABLE trigger
SET ROLE postgres;
ALTER TABLE master_tbl ENABLE TRIGGER ALL;

COMMIT;
